program IO_DEMO; {$C-,U-} (* Suppresses False key presses *)

(* This is a Demonstation Program for the Input/Output Module *)

CONST DATA = $300; (* Addresses of Modules Data and Control Buses *)
      CONTROL = $301;
      A = 1; B = 2; C = 4; D = 8; E = 16; F = 32; (* Mask for Control Bits *)
      Z = 32; Y = 16; X = 8; W = 4; V = 2; U = 1;

TYPE MENU = (OUTPUT, QUIT, ERROR);

VAR Key: CHAR;
    Choice: MENU;
    Mask, Ctrl_Out, Data_Out: INTEGER;

begin (* MAIN *)

   Port [Data] := 0; (* Clear Outputs *)
   Port [CONTROL] := 0;

   Clrscr; GotoXY (1,9); (* Display Menu *)
   WriteLn ('             ͻ');
   WriteLn ('                                I/O MODULE DEMO                   ');
   WriteLn ('             ͹');
   WriteLn ('              INPUT   Reading:      Z:   Y:   X:   W:   V:   U:  ');
   WriteLn ('             Ĵ                                            ');
   WriteLn ('              OUTPUT  Data: 0       A:0  B:0  C:0  D:0  E:0  F:0 ');
   WriteLn ('             ͹');
   WriteLn ('              A-F: TOGGLE BIT, O: OUTPUT DATA             Q: QUIT ');
   WriteLn ('             ͼ');

   repeat

      Choice := ERROR; (* Set Menu Choice to NUL *)

      GotoXY (34,12); Write (Port [DATA]:3); (* Read Data *)

      GotoXY (41,12); Write ((Port [CONTROL] AND Z) DIV Z); (* Read Control *)
      GotoXY (46,12); Write ((Port [CONTROL] AND Y) DIV Y);
      GotoXY (51,12); Write ((Port [CONTROL] AND X) DIV X);
      GotoXY (56,12); Write ((Port [CONTROL] AND W) DIV W);
      GotoXY (61,12); Write ((Port [CONTROL] AND V) DIV V);
      GotoXY (66,12); Write ((Port [CONTROL] AND U) DIV U);

      Mask := 0; (* Clear Mask *)

      if Keypressed then (* Get Choice *)
      begin

         Read (KBD, Key);

         case Key of
            'A', 'a': Mask := A;
            'B', 'b': Mask := B;
            'C', 'c': Mask := C;
            'D', 'd': Mask := D;
            'E', 'e': Mask := E;
            'F', 'f': Mask := F;
            'O', 'o': Choice := OUTPUT;
            'Q', 'q': Choice := QUIT;
         end; (* CASE *)

      end; (* IF *)

      if (Mask > 0) then (* Toggle Bit *)
      begin

         if ((Ctrl_Out AND Mask) = Mask) then Ctrl_Out := Ctrl_Out - Mask else Ctrl_Out := Ctrl_Out + Mask;

         GotoXY (41,14); Write ((Ctrl_Out AND A) DIV A);
         GotoXY (46,14); Write ((Ctrl_Out AND B) DIV B);
         GotoXY (51,14); Write ((Ctrl_Out AND C) DIV C);
         GotoXY (56,14); Write ((Ctrl_Out AND D) DIV D);
         GotoXY (61,14); Write ((Ctrl_Out AND E) DIV E);
         GotoXY (66,14); Write ((Ctrl_Out AND F) DIV F);

         Port [CONTROL] := Ctrl_Out;

      end; (* IF *)

      if (Choice = OUTPUT) then (* Output Data *)
      begin

         repeat

            GotoXY (31,14); Write ('     ');
            GotoXY (31,14); Read (Data_Out);

         until ((Data_Out >= 0) AND (Data_Out <= 255));

         Port [DATA] := Data_Out;

      end; (* IF *)

   until (Choice = QUIT);

   ClrScr;

end. (* MAIN *)