program AD_DEMO; {$C-,U-}

(* This is a Demonstation Program for the Analogue to Digital Module *)

CONST CHANNEL = $302; SIGNAL = $302;
      QUIT = 8; ERROR = 9;

TYPE SIGNAL_ARRAY = Array [0..7] of INTEGER;

VAR Loop, Choice: INTEGER;
    Threshold, Reading: SIGNAL_ARRAY;
    Key: CHAR;

begin (* MAIN *)

   For Loop := 0 to 7 do Threshold [Loop] := 255;

   Clrscr; GotoXY (1,7);
   WriteLn ('         ͻ');
   WriteLn ('                                A/D MODULE DEMO                       ');
   WriteLn ('         ͹');
   WriteLn ('           CHANNEL     0     1     2     3     4     5     6     7   ');
   WriteLn ('         Ĵ                                                 ');
   WriteLn ('           READING                                                   ');
   WriteLn ('         Ĵ                                                 ');
   WriteLn ('          THRESHOLD   255   255   255   255   255   255   255   255  ');
   WriteLn ('         Ĵ                                                 ');
   WriteLn ('            STATE                                                    ');
   WriteLn ('         ͹');
   WriteLn ('          0-7: CHANGE THRESHOLD (RANGE 0-255)                 Q: QUIT ');
   WriteLn ('         ͼ');

   repeat

      Choice := ERROR;

      for Loop := 0  to 7 do (* Read Signals *)
      begin

          Port [CHANNEL] := Loop; Delay (1); Reading [Loop] := Port [SIGNAL];
          GotoXY (25 + (Loop * 6),12); Write (Reading [Loop]:3);

      end; (* LOOP *)

      if Keypressed then (* Get Choice *)
      begin

         Read (KBD, Key);

         case Key of
             '0':      Choice := 0;
             '1':      Choice := 1;
             '2':      Choice := 2;
             '3':      Choice := 3;
             '4':      Choice := 4;
             '5':      Choice := 5;
             '6':      Choice := 6;
             '7':      Choice := 7;
             'Q', 'q': Choice := QUIT;
         end; (* CASE *)

      end; (* IF *)

      if ((Choice >= 0) AND (Choice <= 7)) then (* Set Threshold *)

         repeat

            GotoXY (25 + (Choice * 6),14); Write ('     ');
            GotoXY (25 + (Choice * 6),14); Read (Threshold [Choice]);

         until ((Threshold [Choice] >= 0) AND (Threshold [Choice] <= 255));

      for Loop := 0  to 7 do
      begin

          GotoXY (24 + (Loop * 6),16);

          if (Reading [Loop] < Threshold [Loop]) then Write ('BELOW');
          if (Reading [Loop] = Threshold [Loop]) then Write ('EQUAL');
          if (Reading [Loop] > Threshold [Loop]) then Write ('ABOVE');

      end; (* LOOP *)

   until (Choice = QUIT);

   ClrScr;

end. (* MAIN *)